#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GiantSharkIntegral.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GiantSharkIntegral> Fish_GiantSharkIntegral::msSingleton(nullptr);

int Fish_GiantSharkIntegral::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkIntegralData* Fish_GiantSharkIntegral::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GiantSharkIntegralData>& Fish_GiantSharkIntegral::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkIntegral::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GiantSharkIntegral::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkIntegralData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mMinimumIntegral = element->IntAttribute("MinimumIntegral");
		data.mMaximumIntegral = element->IntAttribute("MaximumIntegral");
		data.mGold = element->IntAttribute("Gold");
		data.mAdditionalRewards = element->IntAttribute("AdditionalRewards");
		data.mRewardCard = element->IntAttribute("RewardCard");
		data.mDisplaySort = element->IntAttribute("DisplaySort");
		data.mDisplayCardType = element->Attribute("DisplayCardType");
		data.mNewGiftWeight = element->IntAttribute("NewGiftWeight");
		data.mNewWeight = element->IntAttribute("NewWeight");
		data.mGiftWeight = element->IntAttribute("GiftWeight");
		data.mComWeight = element->IntAttribute("ComWeight");
		data.mNorWeight = element->IntAttribute("NorWeight");
		data.mOnListWeight = element->IntAttribute("OnListWeight");
		data.mNewGiftWeight1 = element->IntAttribute("NewGiftWeight1");
		data.mNewWeight1 = element->IntAttribute("NewWeight1");
		data.mGiftWeight1 = element->IntAttribute("GiftWeight1");
		data.mComWeight1 = element->IntAttribute("ComWeight1");
		data.mNorWeight1 = element->IntAttribute("NorWeight1");
		data.mOnListWeight1 = element->IntAttribute("OnListWeight1");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GiantSharkIntegral::Load()
{
	Load("../Config/Fish_GiantSharkIntegral.xml");
}

Fish_GiantSharkIntegral* Fish_GiantSharkIntegral::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkIntegral());
	}
	return msSingleton.get();
}
